/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: adc.h 698 2017-07-11 13:16:38Z roi $
 */
/*
 * 
 *  STM32F0xx ADCǥХɥ饤Фγ
 *
 */

#ifndef _ADC_H_
#define _ADC_H_

#ifdef __cplusplus
 extern "C" {
#endif

/*
 *  ADCݡ
 */
#define ADC1_PORTID             1
#define NUM_ADCPORT             1

/*
 *  ADCåץꥹ(ClockPrescaler)
 */
#define ADC_CLOCK_ASYNC_DIV1            0x00000000			/* ADC asynchronous clock derived from ADC dedicated HSI */

#define ADC_CLOCK_SYNC_PCLK_DIV2        ADC_CFGR2_CKMODE_0	/* ADC synchronous clock derived from AHB clock divided by a prescaler of 2 */
#define ADC_CLOCK_SYNC_PCLK_DIV4        ADC_CFGR2_CKMODE_1	/* ADC synchronous clock derived from AHB clock divided by a prescaler of 4 */

/*
 *  ADC꥾塼(Resolution)
 */
#define ADC_RESOLUTION_12B              0x00000000
#define ADC_RESOLUTION_10B              ADC_CFGR1_RES_0
#define ADC_RESOLUTION_8B               ADC_CFGR1_RES_1
#define ADC_RESOLUTION_6B               ADC_CFGR1_RES

/*
 *  ADCǡ饤(DataAlign)
 */ 
#define ADC_DATAALIGN_RIGHT             0x00000000
#define ADC_DATAALIGN_LEFT              ADC_CFGR1_ALIGN

/*
 *  ADC󥳥С⡼(ScanConvMode)
 */
#define ADC_SCANMODE_DISABLE            0x00000000
#define ADC_SCANMODE_ENABLE             0x00000000
#define ADC_SCAN_DIRECTION_FORWARD      ADC_SCANMODE_ENABLE
#define ADC_SCAN_DIRECTION_BACKWARD     ADC_CFGR1_SCANDIR

/*
 *  ADC EOC(EOCSelection)
 */
#define ADC_EOC_SEQ_DISABLE             0x00000000
#define ADC_EOC_SINGLE_CONV             ADC_ISR_EOC
#define ADC_EOC_SEQ_CONV                ADC_ISR_EOS

/*
 *  ADC³⡼(ContinuousConvMode)
 */
#define ADC_CONTINUOUS_DISABLE          0x00000000
#define ADC_CONTINUOUS_ENABLE           ADC_CFGR1_CONT

/*
 *  ADC DMA(DMAContinuousRequests)
 */
#define ADC_DMACONTINUOUS_DISABLE       0x00000000
#define ADC_DMACONTINUOUS_ENABLE        ADC_CFGR1_DMACFG

/*
 *  ADC ³⡼(DiscontinuousConvMode)
 */
#define ADC_DISCONTINUOUS_DISABLE       0x00000000
#define ADC_DISCONTINUOUS_ENABLE        ADC_CFGR1_DISCEN

/*
 *  ADCȥꥬ(ExternalTrigConv)
 */
#define ADC_EXTERNALTRIGCONV_T1_TRGO    0x00000000
#define ADC_EXTERNALTRIGCONV_T1_CC4     ADC_CFGR1_EXTSEL_0
#define ADC_EXTERNALTRIGCONV_T3_TRGO    (ADC_CFGR1_EXTSEL_1 | ADC_CFGR1_EXTSEL_0)
#define ADC_SOFTWARE_START              (ADC_CFGR1_EXTSEL + 1)

/*
 *  ADCȥꥬå(ExternalTrigConvEdge)
 */
#define ADC_EXTERNALTRIGCONVEDGE_NONE           0x00000000
#define ADC_EXTERNALTRIGCONVEDGE_RISING         ADC_CFGR1_EXTEN_0
#define ADC_EXTERNALTRIGCONVEDGE_FALLING        ADC_CFGR1_EXTEN_1
#define ADC_EXTERNALTRIGCONVEDGE_RISINGFALLING  ADC_CFGR1_EXTEN

/*
 *  ADCץ󥰻
 */
#define ADC_SAMPLETIME_1CYCLE_5         0x10000000			/* ADC sampling time 1.5 ADC clock cycle */
#define ADC_SAMPLETIME_7CYCLES_5        ADC_SMPR_SMP_0		/* ADC sampling time 7.5 clock cycles */
#define ADC_SAMPLETIME_13CYCLES_5       ADC_SMPR_SMP_1		/* ADC sampling time 13.5 clock cycles */
#define ADC_SAMPLETIME_28CYCLES_5       (ADC_SMPR_SMP_1 | ADC_SMPR_SMP_0)	/* ADC Sampling time 28.5 clock cycles */
#define ADC_SAMPLETIME_41CYCLES_5       ADC_SMPR_SMP_2		/* ADC sampling time 41.5 clock cycles */
#define ADC_SAMPLETIME_55CYCLES_5       (ADC_SMPR_SMP_2 | ADC_SMPR_SMP_0)	/* ADC Sampling time 55.5 clock cycles */
#define ADC_SAMPLETIME_71CYCLES_5       (ADC_SMPR_SMP_2 | ADC_SMPR_SMP_1)	/* ADC Sampling time 71.5 clock cycles */
#define ADC_SAMPLETIME_239CYCLES_5      ADC_SMPR_SMP		/* ADC Sampling time 239.5 clock cycles */

/*
 * ADCѥȥѥ
 */
#define ADC_LOWAUTOPOWEROFF_DISABLE     0x00000000
#define ADC_LOWAUTOPOWEROFF_ENABLE      ADC_CFGR1_AUTOFF

/*
 *  ADCѥȥ
 */
#define ADC_LOWAUTOWAIT_DISABLE         0x00000000
#define ADC_LOWAUTOWAIT_ENABLE          ADC_CFGR1_WAIT

/*
 *  ADCСǡ饤ƥ
 */
#define ADC_OVR_DATA_PRESERVED          0x00000000
#define ADC_OVR_DATA_OVERWRITTEN        ADC_CFGR1_OVRMOD


/*
 *  ADCͥ
 */
#define ADC_CHANNEL_0                   ADC_CHSELR_CHSEL0
#define ADC_CHANNEL_1                   ADC_CHSELR_CHSEL1
#define ADC_CHANNEL_2                   ADC_CHSELR_CHSEL2
#define ADC_CHANNEL_3                   ADC_CHSELR_CHSEL3
#define ADC_CHANNEL_4                   ADC_CHSELR_CHSEL4
#define ADC_CHANNEL_5                   ADC_CHSELR_CHSEL5
#define ADC_CHANNEL_6                   ADC_CHSELR_CHSEL6
#define ADC_CHANNEL_7                   ADC_CHSELR_CHSEL7
#define ADC_CHANNEL_8                   ADC_CHSELR_CHSEL8
#define ADC_CHANNEL_9                   ADC_CHSELR_CHSEL9
#define ADC_CHANNEL_10                  ADC_CHSELR_CHSEL10
#define ADC_CHANNEL_11                  ADC_CHSELR_CHSEL11
#define ADC_CHANNEL_12                  ADC_CHSELR_CHSEL12
#define ADC_CHANNEL_13                  ADC_CHSELR_CHSEL13
#define ADC_CHANNEL_14                  ADC_CHSELR_CHSEL14
#define ADC_CHANNEL_15                  ADC_CHSELR_CHSEL15
#define ADC_CHANNEL_16                  ADC_CHSELR_CHSEL16
#define ADC_CHANNEL_17                  ADC_CHSELR_CHSEL17
#define ADC_CHANNEL_18                  ADC_CHSELR_CHSEL18

#define ADC_CHANNEL_TEMPSENSOR          ADC_CHANNEL_16
#define ADC_CHANNEL_VREFINT             ADC_CHANNEL_17
#define ADC_CHANNEL_VBAT                ADC_CHANNEL_18

/*
 *  ADCͥ
 */
#define ADC_RANK_CHANNEL_NUMBER         0x00001000	/* ͥΥͭ */
#define ADC_RANK_NONE                   0x00001001	/* ͥΥ̵ */

/*
 *  ADCʥåɥå⡼
 */
#define ADC_ANALOGWATCHDOG_NONE         0x00000000
#define ADC_ANALOGWATCHDOG_SINGLE_REG   (ADC_CFGR1_AWD1SGL | ADC_CFGR1_AWD1EN))
#define ADC_ANALOGWATCHDOG_ALL_REG      ADC_CFGR1_AWD1EN

/*
 *  ADCʥåɥåߥ⡼
 */
#define ADC_ANALOGWATCHDOG_ITMODE_DISABLE     0x00000000
#define ADC_ANALOGWATCHDOG_ITMODE_ENABLE      ADC_IER_AWD1IE

/*
 *  ADCϡɥ깽¤
 */
typedef struct _ADC_PortControlBlock{
	uint32_t              base;
	uint32_t              adcclockbase;
	uint32_t              adcclockbit;
	uint32_t              dmaclockbase;
	uint32_t              dmaclockbit;
	uint32_t              dmarxchannel;
	uint32_t              dmarxrequest;
} ADC_PortControlBlock;

/*
 *  ADCν¤
 */
typedef struct
{
	uint32_t              ClockPrescaler;				/* ADCåץꥹ(ADCˤƶ) */
	uint32_t              Resolution;					/* ADCΥ꥾塼 */
	uint32_t              DataAlign;					/* ADC̥ǡ饤 */
	uint32_t              ScanConvMode;					/* ADC󥳥С⡼ */
	uint32_t              EOCSelection;					/* ADC EOC */
	uint32_t              ContinuousConvMode;			/* ADC³⡼ */
	uint32_t              DMAContinuousRequests;		/* ADC-DMA⡼ */
	uint32_t              DiscontinuousConvMode;		/* ADC³⡼ */
	uint32_t              ExternalTrigConv;				/* ADCȥꥬ */
	uint32_t              ExternalTrigConvEdge;			/* ADCȥꥬå */
 	uint32_t              SamplingTime;					/* ADCץ󥰻 */

	uint32_t              LowPowerAutoPowerOff;			/* ADCѥȥץ󥰥 */
	uint32_t              LowPowerAutoWait;				/* ADCѥȥ */
	uint32_t              Overrun;						/* ADCDR쥸ΥС񤭹 */
}ADC_Init_t;

/*
 *  ADCϥɥ鹽¤
 */ 
typedef struct __ADC_Handle_t ADC_Handle_t;
struct __ADC_Handle_t
{
	uint32_t              base;							/* ADC١ɥ쥹 */
	ADC_Init_t            Init;							/* ADCǡ */
	volatile uint32_t     NumCurrentConversionRank;		/* ADCߤΥС */
	DMA_Handle_t          *hdmarx;						/* ADCDMAϥɥؤΥݥ */
	void                  (*xfercallback)(ADC_Handle_t * hadc);		/* ADC žλХå */
	void                  (*xferhalfcallback)(ADC_Handle_t * hadc);	/* ADC ȾʬžХå */
	void                  (*outofwincallback)(ADC_Handle_t * hadc);	/* ADC ʥåɥåХå */
	void                  (*errorcallback)(ADC_Handle_t * hadc);	/* ADC 顼Хå */
	volatile uint32_t     status;						/* ADCơ */
	volatile uint32_t     errorcode;					/* ADC顼 */
};

/*
 *  ͥ깽¤
 */
typedef struct
{
	uint32_t              Channel;						/* ADCֹͥ */
	uint32_t              Rank;							/* ADCֹ(1-16) */
	uint32_t              GpioBase;						/* ADC-GPIO١ɥ쥹 */
	uint32_t              GpioPin;						/* ADC-GPIOԥֹ */
}ADC_ChannelConf_t;

/*
 *  ADCʥåɥå깽¤
 */
typedef struct
{
	uint32_t              WatchdogMode;					/* ADCʥåɥå⡼ */
	uint32_t              HighThreshold;				/* ADCåۡɾ */
	uint32_t              LowThreshold;					/* ADCåۡɲ */
	uint32_t              Channel;						/* ADCбֹͥ */
	uint32_t              ITMode;						/* ADCʥåɥå */
}ADC_AnalogWDGConf_t;

/*
 *  ADCΥơ
 */
#define ADC_STATUS_RESET        0x00    /* ADC ̤Ѿ */
#define ADC_STATUS_READY        0x01    /* ADC ǥ */
#define ADC_STATUS_BUSY         0x02    /* ADC ӥ */
#define ADC_STATUS_EOC          0x10    /* ADC λ */
#define ADC_STATUS_BUSY_EOC     0x12    /* ADC ӥλȯ */ 
#define ADC_STATUS_AWD          0x20    /* ADC ʥåɥåȯ */
#define ADC_STATUS_ERROR		0x40	/* ADC 顼 */

/*
 *  ADC顼
 */
#define ADC_ERROR_NONE          0x00	/* No error             */
#define ADC_ERROR_OVR           0x01	/* OVR error            */
#define ADC_ERROR_DMA           0x02	/* DMA transfer error   */
#define ADC_ERROR_INT           0x04	/* INTERNAL error       */


extern ADC_Handle_t *adc_init(ID portid, ADC_Init_t *pini);
extern ER adc_deinit(ADC_Handle_t *hadc);
extern ER adc_start_int(ADC_Handle_t* hadc);
extern ER adc_end_int(ADC_Handle_t* hadc);
extern ER adc_start_dma(ADC_Handle_t* hadc, uint16_t* pdata, uint32_t length);
extern ER adc_end_dma(ADC_Handle_t* hadc);
extern ER adc_setupchannel(ADC_Handle_t* hadc, ADC_ChannelConf_t* sConfig);
extern ER adc_setupwatchdog(ADC_Handle_t* hadc, ADC_AnalogWDGConf_t* AnalogWDGConfig);
extern uint32_t adc_getvalue(ADC_Handle_t* hadc);

extern void adc_handler(ADC_Handle_t* hadc);
extern void adc_int_handler(void);

#ifdef __cplusplus
}
#endif

#endif	/* _ADC_H_ */

