/*
 *  TOPPERS BASE PLATFORM MIDDLEWARE
 * 
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT
 *                             Educational Working Group.
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: tusbh_rtos.h 698 2018-04-04 21:04:00Z roi $
 */
/*
 *  USB Middleware RTOS¸
 */

#ifndef _TUSB_RTOS_H_
#define _TUSB_RTOS_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include <sil.h>
#include <target_syssvc.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "t_syslog.h"
#include "device.h"

#ifdef CACHE_LINE_SIZE
#define USB_DATA_ALIGN      CACHE_LINE_SIZE
#else
#define USB_DATA_ALIGN      4
#endif

#define TUSB_PROCESS_PRIO       6
#define TUSB_PROCESS_STACK_SIZE 4096
#define TUSB_HANDLE_STACK_SIZE  1024

/*
 *  SYSSVCؿ
 */
extern void *malloc_cache(uint32_t len);
extern void free_cache(void *addr);


extern ER tusbSendData(ID qid, uint8_t evt, uint8_t prm1, uint8_t prm2, uint8_t prm3);
extern ER tusbiSendData(ID qid, uint8_t evt, uint8_t prm1, uint8_t prm2, uint8_t prm3);
extern ER tusbRecvData(ID qid, uint8_t *pmes, uint32_t timeout);
extern ER tusbStartTask(ID taskid);
extern int32_t tusbGetTaskID(void);
extern ER tusbTimerControl(uint8_t activate);

#define tusbmalloc          malloc_cache
#define tusbfree            free_cache
extern void tusbmemset(void *d, const char val, int len);
extern void tusbmemcpy(void *d, void *s, int len);

#define tusbCpuLock         loc_cpu
#define tusbCpuUnLock       unl_cpu
#define tusbDelay(t)        dly_tsk((t))
#define tusbSleep(t)        tslp_tsk((t))
#define tusbWakeup(id)      wup_tsk((id))


#endif /* _TUSB_RTOS_H_ */

